
#include "includes.h"
#include "installergui_data.h"

/********************************************************************
 *
 *  DESCRIPTION
 *
 *  this function cleans the GUI; i.e. it removes a content (as it
 *  may be set by igui_Ask* functions) from the InstallerNG window
 *  and clears the help text.
 *
 *  IN:  application - pointer to the private application structure
 *  OUT: -
 *
 */

/********************************************************************
 *
 *  STATIC
 *
 */

/********************************************************************
 *
 *  EXTERN
 *
 */

/********************************************************************
 *
 *  PUBLIC
 *
 */

/********************************************************************
 *
 *  CODE
 *
 */

void __asm igui_EmptyPanel(register __a0 APTR application)
{
  #ifdef DEBUG
  DEBUG_MAKRO
  #endif

  guistuff_NewContent(application, HVSpace);

  // remove the help text, cause this panel does not have any help
  // and the function gets called by others to remove the content
  // of the other functions
  igui_SetHelp(application, ((struct Application *) application)->app_Texts[EMPTY]);
}
