
#include "includes.h"
#include "installergui_data.h"

/********************************************************************
 *
 *  DESCRIPTION
 *
 *  dispose the application an related resources; note that
 *  the argument can also be NULL!
 *
 *  IN:  application - pointer to the private application structure
 *  OUT: -
 *
 */

/********************************************************************
 *
 *  STATIC
 *
 */

/********************************************************************
 *
 *  EXTERN
 *
 */

/********************************************************************
 *
 *  PUBLIC
 *
 */

/********************************************************************
 *
 *  CODE
 *
 */

void __asm igui_FreeApp(register __a0 APTR application)
{
  #ifdef DEBUG
  DEBUG_MAKRO
  #endif

  if (application)
  {
    struct Application *app = (struct Application *) application;

    // dispose the complete mui application
    if (app->app_Application) { DisposeObject(app->app_Application); }

    // free the application memory itself
    FreeVec(app);
  }

  // close the mui library
  if (MUIMasterBase) { CloseLibrary(MUIMasterBase); }
}
