
#include "includes.h"
#include "installergui_data.h"

/********************************************************************
 *
 *  DESCRIPTION
 *
 *  pop up a standard requester. the complete GUI must be locked
 *  during the time the requester is visible.
 *  NOTE: see intuition.EasyRequestArgs for additional explanation
 *
 *  IN: application - pointer to the private application structure
 *      title - title of the requester
 *      gads - the gadget text of the requester, seperated by |
 *      body - a text for the body of the requester; may contain
 *             standard format strings
 *      args - pointer to the arguments, which should replace the
 *             format characters in body
 *
 *  OUT: the number of the selected button (see intuition.EasyRequestArgs
 *       for more details)
 *
 */

/********************************************************************
 *
 *  STATIC
 *
 */

/********************************************************************
 *
 *  EXTERN
 *
 */

/********************************************************************
 *
 *  PUBLIC
 *
 */

/********************************************************************
 *
 *  CODE
 *
 */

long __asm igui_Request(register __a0 APTR application,
                        register __a1 char *title,
                        register __a2 char *gads,
                        register __d0 char *body,
                        register __d1 APTR args)

{
  #ifdef DEBUG
  DEBUG_MAKRO
  #endif

  {
    struct Application *app = (struct Application *) application;

    // request
    return(MUI_RequestA(app->app_Application,
                        app->app_MainWindow,
                        0, title, gads, body, args));
  }
}

