
#include "includes.h"
#include "installergui_data.h"

/********************************************************************
 *
 *  DESCRIPTION
 *
 *  with a call to this function, the InstallerNG informs the GUI
 *  that it now starts or ends the interpretation of several TRAP
 *  statements. as shown in the igui_WaitApp() function, the GUI
 *  has to distinguish between normal mode, SWING mode and TRAP
 *  mode
 *
 *  IN:  application - pointer to the private application structure
 *       mode - TRUE or FALSE, depends on whether the InstallerNG
 *              enters (TRUE) or exits (FALSE) the TRAP mode
 *
 *  OUT: the mode argument itself
 *
 */

/********************************************************************
 *
 *  STATIC
 *
 */

/********************************************************************
 *
 *  EXTERN
 *
 */

/********************************************************************
 *
 *  PUBLIC
 *
 */

/********************************************************************
 *
 *  CODE
 *
 */

BOOL __asm igui_TRAP_Mode(register __a0 APTR application,
                          register __d0 BOOL mode)
{
  #ifdef DEBUG
  DEBUG_MAKRO
  #endif

  ((struct Application *) application)->app_TRAP_Mode = mode;
  return (mode);
}
